#!/bin/sh

VERSION=$1
ZIP_FILE=$2
PLUGIN_ID=$3
FREEMIUS_DEVELOPER_ID=$4
FREEMIUS_API_SECRET=$5

# Create a new plugin tag in Freemius
TAG_ID=$(curl -X POST "https://api.freemius.com/v1/developers/$FREEMIUS_DEVELOPER_ID/plugins/$PLUGIN_ID/tags.json" \
  -H "Content-Type: application/json" \
  -H "Authorization: FSA $FREEMIUS_DEVELOPER_ID:$FREEMIUS_API_SECRET" \
  -d "{ \"tag\": { \"version\": \"$VERSION\" } }" \
  | jq -r '.id')

# Upload the zip file to Freemius
curl -X POST "https://api.freemius.com/v1/developers/$FREEMIUS_DEVELOPER_ID/plugins/$PLUGIN_ID/tags/$TAG_ID.json" \
  -H "Content-Type: multipart/form-data" \
  -H "Authorization: FSA $FREEMIUS_DEVELOPER_ID:$FREEMIUS_API_SECRET" \
  -F "file=@$ZIP_FILE"
